/*
  Filtrage numérique avec un Arduino (AtMega328p)

  fe= 8600 Hz hz pour 6 coefs max

  temps de calcul : 110us

  utilisation de FII Filter Designer Ver. 6.6

  http://www.iowahills.com/8DownloadPage.html

//Entrée analogique A0 tension sinusoïdale alternative de 500 Hz, d’amplitude crête à crête(Vpp) de 2.83V et de valeur moyenne 2.5V.
//sortie PWM sur OCR2A D11 CH1 , filtre analogique RC passe bas R=10K C=10nF
//Tech sur D2

*/


float y[] = {0, 0, 0}; //initialisation
float x[] = {0, 0, 0}; //initialisation


//fc 500hz low pass
//float a[]={}; //Denominator
//float b[]={}; //Numerator


//fc 500hz high pass
//float a[]={}; //Denominator
//float b[]={}; //Numerator


//fc 500hz band pass
//float a[]={}; //Denominator
//float b[]={}; //Numerator


//fc 500hz ,notch
//float a[] = {}; //Denominator
//float b[] = {}; //Numerator



ISR (TIMER0_COMPA_vect) {
  PORTD |= 4;
  x[0] = (float)  ADCH - 128;

  y[0] =  x[0] * b[0] + x[1] * b[1] + x[2] * b[2] - y[1] * a[1] - y[2] * a[2] ;
  OCR2A = (byte) y[0] + 128;

  x[2] = x[1];
  x[1] = x[0];
  y[2] = y[1];
  y[1] = y[0];

  PORTD &= ~4;
}

int main(void)
{

  Serial.begin(115200);
  DDRD = 254;
  DDRB = 255;

  cli();
  TCCR0A = (1 << WGM01); //CTC mode
  TCCR0B = (1 << CS01) | (1 << CS00); // FREQ 16Mhz/64 = 250 000

  //5Khz= 16Mhz/(64 * (OCR0A +1))   ORC0A= (16Mhz / (64 * 5Khz)) -1  =49
  //10Khz= 16Mhz/(64 * (OCR0A +1))  ORC0A= (16Mhz / (64 * 5Khz)) -1  =24


  OCR0A = 28;
  TIMSK0 = (1 << OCIE0A); //irq



  TCCR2A = 0xA3; //timer 0 fast PWm at PD5/6
  TCCR2B = 0x01; //16Mhz
  OCR2A = 128;

  ADMUX   = 0x40 ;                    // channel0, ref to internal input (vcc)
  ADMUX  |= (1 << ADLAR) ;            // left-justified (only need 8 bits)
  ADCSRA  = (1 << ADPS2) ;            // pre-scale 16
  ADCSRA |= (1 << ADATE) ;            // auto-trigger (free-run)
  ADCSRB  = 0x00 ;                    // free-running
  DIDR0  |= (1 << ADC0D) ;            // disable digital driver on ADC0
  ADCSRA |= (1 << ADEN) ;             // enable ADC
  ADCSRA |= (1 << ADSC) ;             // trigger first conversion

  sei();
  while (true) {
  }
}
